QuantLib: HybridHestonHullWhiteProcess Class Reference

A free/open-source library for quantitative finance Reference manual - version 1.20

Public Types | Public Member Functions | Protected Attributes | List of all members
HybridHestonHullWhiteProcess Class Reference
Stochastic processes

Hybrid Heston Hull-White stochastic process. More...

`#include <ql/processes/hybridhestonhullwhiteprocess.hpp>`

Inheritance diagram for HybridHestonHullWhiteProcess:
[legend]

## Public Types
enum | Discretization { Euler, BSMHullWhite }
Public Types inherited from Observer
typedef boost::unordered_set< ext::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator

## Public Member Functions
| HybridHestonHullWhiteProcess (const ext::shared_ptr< HestonProcess > &hestonProcess, const ext::shared_ptr< HullWhiteForwardProcess > &hullWhiteProcess, Real corrEquityShortRate, Discretization discretization=BSMHullWhite)
Size | size () const
| returns the number of dimensions of the stochastic process
Disposable< Array > | initialValues () const
| returns the initial values of the state variables
Disposable< Array > | drift (Time t, const Array &x) const
| returns the drift part of the equation, i.e., \( \mu(t, \mathrm{x}_t) \)
Disposable< Matrix > | diffusion (Time t, const Array &x) const
| returns the diffusion part of the equation, i.e. \( \sigma(t, \mathrm{x}_t) \)
Disposable< Array > | apply (const Array &x0, const Array &dx) const
Disposable< Array > | evolve (Time t0, const Array &x0, Time dt, const Array &dw) const
DiscountFactor | numeraire (Time t, const Array &x) const
const ext::shared_ptr< HestonProcess > & | hestonProcess () const
const ext::shared_ptr< HullWhiteForwardProcess > & | hullWhiteProcess () const
Real | eta () const
Time | time (const Date &date) const
Discretization | discretization () const
void | update ()
Public Member Functions inherited from StochasticProcess
virtual Size | factors () const
| returns the number of independent factors of the process
virtual Disposable< Array > | expectation (Time t0, const Array &x0, Time dt) const
virtual Disposable< Matrix > | stdDeviation (Time t0, const Array &x0, Time dt) const
virtual Disposable< Matrix > | covariance (Time t0, const Array &x0, Time dt) const
void | update ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const ext::shared_ptr< Observable > &)
void | registerWithObservables (const ext::shared_ptr< Observer > &)
Size | unregisterWith (const ext::shared_ptr< Observable > &)
void | unregisterWithAll ()
virtual void | deepUpdate ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()

## Protected Attributes
const ext::shared_ptr< HestonProcess > | hestonProcess_
const ext::shared_ptr< HullWhiteForwardProcess > | hullWhiteProcess_
const ext::shared_ptr< HullWhite > | hullWhiteModel_
const Real | corrEquityShortRate_
const Discretization | discretization_
const Real | maxRho_
const Time | T_
DiscountFactor | endDiscount_
Protected Attributes inherited from StochasticProcess
ext::shared_ptr< discretization > | discretization_

## Additional Inherited Members
Protected Member Functions inherited from StochasticProcess
| StochasticProcess ()
| StochasticProcess (const ext::shared_ptr< discretization > &)

## Detailed Description

Hybrid Heston Hull-White stochastic process.

This class implements a three factor Heston Hull-White model

Bug:
  This class was not tested enough to guarantee its functionality... work in progress

## Member Function Documentation

## ◆ apply()

Disposable<Array> apply | ( | const Array & | x0,
|  | const Array & | dx
| ) |  | const
| virtual

applies a change to the asset value. By default, it returns \( \mathrm{x} + \Delta \mathrm{x} \).

Reimplemented from StochasticProcess.

## ◆ evolve()

Disposable<Array> evolve | ( | Time | t0,
|  | const Array & | x0,
|  | Time | dt,
|  | const Array & | dw
| ) |  | const
| virtual

returns the asset value after a time interval \( \Delta t \) according to the given discretization. By default, it returns

\[ E(\mathrm{x}_0,t_0,\Delta t) + S(\mathrm{x}_0,t_0,\Delta t) \cdot \Delta \mathrm{w} \]

where \( E \) is the expectation and \( S \) the standard deviation.

Reimplemented from StochasticProcess.

## ◆ time()

Time time | ( | const Date & |  | ) | const
| virtual

returns the time value corresponding to the given date in the reference system of the stochastic process.

Note
  As a number of processes might not need this functionality, a default implementation is given which raises an exception.

Reimplemented from StochasticProcess.

## ◆ update()

void update | ( |  | ) |
| virtual

This method must be implemented in derived classes. An instance of Observer does not call this method directly: instead, it will be called by the observables the instance registered with when they need to notify any changes.

Implements Observer.